/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../util/structure/unique_no_blank_string_map.dart';

class Extras {
  // @ElementMap(entry = Defaults.FIELD, key = Defaults.ID, attribute = true, inline = true, keyType = String,
  //         valueType = String, required = false)
  UniqueNoBlankStringMap fields;

  Extras() {
    // default constructor required for de/serialization
  }

  Extras.json(Map json) {
    if (json.containsKey('fields')) {
      this.fields = UniqueNoBlankStringMap();

      for (String key in (json['fields'] as Map).keys) {
        this.fields[key] = json['fields'][key];
      }
    }
  }

  UniqueNoBlankStringMap getFields() {
    return fields;
  }
}
