/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../../../../error/unsupported_operation_exception.dart';
import '../../renderer/ui_renderer.dart';
import '../../view_state.dart';

class CommActions {
  final UIRenderer renderer;

  const CommActions(this.renderer);

  void doSendSms(ViewState view) {
    throw UnsupportedOperationException.msg("Send SMS is not supported.");
  }
}
