/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'utils.dart';

// FIXME?
class ImageUtils {
  static const String PNG = "PNG";
  static const String JPEG = "JPEG";
  static const String DEFAULT = JPEG;

  const ImageUtils._();

  // static bool isReadable(Object image) {
  //   try {
  //     return toImage(image) != null;
  //   } catch (e, stackTrace) {
  //     Logger.error(e, stackTrace: stackTrace);
  //     return false;
  //   }
  // }

  // static BufferedImage toImage(String path) {
  //     return toImage(IOUtils.getFileIfExists(path));
  // }

  // static BufferedImage toImage(Object image) {
  //     if (image == null) {
  //         return null;
  //     }
  //
  //     // TODO If image is InputStream, it won't work because we can't read it multiple times
  //     BufferedImage rgbImage = toRgbImage(image);
  //     return rgbImage == null && Utils.equalsIgnoreCase(DEFAULT, getFormatNoErr(image)) ? readCMYK(image) : rgbImage;
  // }

  // static BufferedImage toRgbImage(Object image) {
  //     try {
  //         if (image is File) {
  //             return ImageIO.read((File) image);
  //         } else if (image is ImageInputStream) {
  //             return ImageIO.read((ImageInputStream) image);
  //         } else if (image is InputStream) {
  //             return ImageIO.read((InputStream) image);
  //         } else if (image is URL) {
  //             return ImageIO.read((URL) image);
  //         } else if (image is List<int>) {
  //             try (InputStream inputStream = IOUtils.toStream((List<int>) image)) {
  //                 return toRgbImage(inputStream);
  //             }
  //         }
  //     } catch (e) {
  //         return null;
  //     }
  //
  //     throw IllegalArgumentException("Provided image is of unknown class!");
  // }

  // static List<int> toBytes(BufferedImage image, String format) {
  //     if (image == null) {
  //         return null;
  //     }
  //
  //     try (ByteArrayOutputStream outputStream = ByteArrayOutputStream()) {
  //         if (!write(image, format, outputStream)) {
  //             write(image, JPEG, outputStream); // try to write it as JPEG
  //         }
  //
  //         return outputStream.toByteArray();
  //     }
  // }

  // static bool write(BufferedImage image, String format, OutputStream out) {
  //     return ImageIO.write(image, toDefault(format), out);
  // }

  // static List<int> decodeWsqNoErr(List<int> wsq) {
  //     try {
  //         return decodeWsq(wsq);
  //     } catch (e) {
  //         return wsq;
  //     }
  // }

  // static List<int> decodeWsq(List<int> wsq) {
  //     if (Utils.isBlank(wsq)) {
  //         return null;
  //     }
  //
  //     Bitmap bitmap = WsqDecoder().decode(wsq);
  //     return org.jnbis.ImageUtils().bitmap2jpeg(bitmap);
  // }

  // static BufferedImage decodeWsqAsImage(List<int> value) {
  //     return toImage(decodeWsq(value));
  // }

  // static int getSize(BufferedImage image, String format) {
  //   try {
  //     return IOUtils.getSize(toBytes(image, format));
  //   } catch (e, stackTrace) {
  //     Logger.error(e, stackTrace: stackTrace);
  //     return Defaults.MISSING; // couldn't calculate
  //   }
  // }

  // static String getFormatNoErr(Object image) {
  //     try {
  //         return getFormat(image);
  //     } catch (e) {
  //         return DEFAULT;
  //     }
  // }

  // static String getFormat(Object image) {
  //     ImageReader reader = getReader(image);
  //     return Utils.toDefault(reader == null ? null : reader.getFormatName(), DEFAULT);
  // }

  // static ImageReader getReader(Object image) {
  //     try (ImageInputStream imageStream = image == null ? null : getImageInputStream(image)) {
  //         return getReader(imageStream);
  //     }
  // }

  // static ImageReader getReader(ImageInputStream imageStream) {
  //     Iterator<ImageReader> readers = imageStream == null ? null : ImageIO.getImageReaders(imageStream);
  //     ImageReader imageReader = readers != null && readers.hasNext() ? readers.next() : null;
  //
  //     if (imageReader == null) {
  //         Logger.warn("Unable to find a suitable ImageReader for the provided image!");
  //     }
  //
  //     return imageReader;
  // }

  // static ImageReader getJpegReader() {
  //     Iterator<ImageReader> readers = ImageIO.getImageReadersByFormatName(JPEG);
  //     ImageReader reader = null;
  //
  //     while (readers.hasNext()) {
  //         reader = readers.next();
  //
  //         if (reader.canReadRaster()) {
  //             break;
  //         }
  //     }
  //
  //     return reader;
  // }

  // static BufferedImage readCMYK(Object image) {
  //     BufferedImage cmykImage = toCMYKImage(image);
  //     BufferedImage rgbImage = null;
  //
  //     if (cmykImage != null) {
  //         rgbImage = BufferedImage(cmykImage.getWidth(), cmykImage.getHeight(), BufferedImage.TYPE_3BYTE_BGR);
  //         ColorConvertOp(null).filter(cmykImage, rgbImage);
  //     }
  //
  //     return rgbImage;
  // }

  // static BufferedImage toCMYKImage(Object image) {
  //     BufferedImage cmykImage = null;
  //
  //     try (ImageInputStream imageStream = getImageInputStream(image)) { // Stream the original CMYK image
  //         if (imageStream != null) {
  //             ImageReader reader = getJpegReader();
  //             reader.setInput(imageStream);
  //
  //             Raster raster = reader.readRaster(0, null); // Read the image raster
  //
  //             cmykImage = BufferedImage(raster.getWidth(), raster.getHeight(), BufferedImage.TYPE_4BYTE_ABGR);
  //             cmykImage.getRaster().setRect(raster); // Fill the new image with the old raster
  //         }
  //     }
  //
  //     return cmykImage;
  // }

  // static ImageInputStream getImageInputStream(Object image) {
  //     try (InputStream inputStream = image is List<int> ? IOUtils.toStream((List<int>) image) : null) {
  //         return ImageIO.createImageInputStream(inputStream == null ? image : inputStream);
  //     }
  // }

  static String toDefault(String format) {
    return Utils.toDefault(format, DEFAULT);
  }
}
