/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'abstract_isl_req.dart';

abstract class AbstractIslReqMetaData {
  static const String trxId = "trxId";
  static const String instanceId = "instanceId";
  static const String idCompany = "idCompany";
  static const String createdDateTime = "createdDateTime";
  static const String locale = "locale";

  static Set<String> getFields() =>
      {trxId, instanceId, idCompany, createdDateTime, locale};

  static dynamic getFieldValue(String field, AbstractIslReq abstractIslReq) {
    if (trxId == field) return abstractIslReq.getTrxId();
    if (instanceId == field) return abstractIslReq.getInstanceId();
    if (idCompany == field) return abstractIslReq.getIdCompany();
    if (createdDateTime == field) return abstractIslReq.getCreatedDateTime();
    if (locale == field) return abstractIslReq.getLocale();

    return null;
  }
}
