/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

/// Only generic mPosConstant share across all project.
class BaseMposConstant {
  // Soap Properties
  static const String PROP_REQUEST_COMPANY_ID = "companyId";
  static const String PROP_REQUEST_IMEI = "imei";
  static const String PROP_REQUEST_CELL_ID = "cellId";
  static const String PROP_REQUEST_FORM_ID = "formId";
  static const String PROP_REQUEST_MPOS_VERSION_NAME = "mPosVersionName";
  static const String PROP_REQUEST_MPOS_VERSION_CODE = "mPosVersionCode";
  static const String PROP_REQUEST_SECURITY_TOKEN = "securityToken";
  static const String PROP_REQUEST_IS_OFFLINE = "isOffline";
  static const String PROP_REQUEST_START_REGIS_TIME = "startRegistrationTime";
  static const String PROP_REQUEST_END_REGIS_TIME = "endRegistrationTime";
  static const String PROP_REQUEST_SEND_REGIS_TIME = "sendRegistrationTime";
  static const String PROP_REQUEST_NATIONALITY_TYPE = "nationality";
  static const String PROP_REQUEST_IDNUMBER = "idNumber";
  static const String PROP_REQUEST_PASSPORTNO = "passportNo";
  static const String PROP_REQUEST_COUNTRY_CODE = "countryCode";
  static const String PROP_REQUEST_REGISTRATION_TYPE = "registerType";
  static const String PROP_REQUEST_LOCALE = "locale";

  static const String PROP_RESPONSE_REPORT_FAILED = "nbFailedRegistrations";
  static const String PROP_RESPONSE_REPORT_PENDING = "nbPendingRegistrations";
  static const String PROP_RESPONSE_REPORT_SUCCESS = "nbSuccessRegistrations";
  static const String PROP_RESPONSE_REPORT_TOTAL = "nbTotalRegistrations";

  static const String PROPERTY_ANDROID_VERSION = "androidVersion";
  static const String PROPERTY_PHONE_MODEL = "phoneModel";
  static const String PROPERTY_PHONE_SN = "phoneSerialNumber";
  static const String PROPERTY_PRIMARY_MSISDN = "primaryMsisdn";
  static const String PROPERTY_REGISTERATION_CRMFORMDATA_MAP = "map";
  static const String PROPERTY_REGISTERATION_CRMFORMDATA = "crmFormData";
  static const String PROPERTY_REGISTERATION_ACTIONDATE = "actionDate";
  static const String PROPERTY_REGISTERATION_CREATE_DATE_TIME =
      "createdDateTime";
  static const String PROPERTY_REGISTERATION_INSTANCE_ID = "instanceId";
  static const String PROPERTY_REGISTERATION_EXT_ISSMSSENT = "EXT_ISSMSSENT";
  static const String PROPERTY_REGISTERATION_ADDTIONAL_LIST_NUMBER =
      "addRegDatas";
  static const String PROPERTY_REGISTERATION_ADDTIONAL_NUMBER = "addRegData";
  static const String PROPERTY_REGISTERATION_RECIEVE_REGIS_TIME =
      "receivedRegistrationTime";
  static const String PROPERTY_REGISTERATION_REGIS_TYPE_ID =
      "registrationTypeId";
  static const String PROPERTY_REGISTERATION_IS_PRIMARY_NUMBER = "isMultiple";
  static const String PROPERTY_REGISTERATION_TX_EVENT_ID = "trxEventId";
  static const String PROPERTY_REGISTERATION_TX_EVENT_TYPE_ID =
      "trxEventTypeId";
  static const String PROPERTY_REGISTERATION_TX_ID = "trxId";
  static const String PROPERTY_REGISTERATION_UPDATED_DATE_TIME =
      "updatedDateTime";
  static const String PROPERTY_REGISTERATION_USERNAME = "username";
  static const String PROPERTY_REGISTERATION_PIN = "pincode";
  static const String PROPERTY_REGISTERATION_LATITUDE = "latitude";
  static const String PROPERTY_REGISTERATION_LONGITUDE = "longitude";

  static const String PROPERTY_HASH_KEY = "key";
  static const String PROPERTY_HASH_VALUE = "value";
  static const String PROPERTY_CUSTOMER_INFORMATION = "customerInformation";
  static const String PROPERTY_TRX_TYPE_ID = "trxTypeId";
  static const String PROPERTY_ENTRY = "entry";
  static const String PROPERTY_ENTRY_KEY = "key";
  static const String PROPERTY_ENTRY_VALUE = "value";
}
