/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'add_reg_data.dart';

abstract class AddRegDataMetaData {
  static const String trxId = "trxId";
  static const String trxStatusId = "trxStatusId";
  static const String trxStatusDescription = "trxStatusDescription";
  static const String trxTypeId = "trxTypeId";
  static const String trxEventId = "trxEventId";
  static const String trxEventTypeId = "trxEventTypeId";
  static const String primaryMsisdn = "primaryMsisdn";
  static const String map = "map";
  static const String state = "state";
  static const String stateInfo = "stateInfo";
  static const String retries = "retries";
  static const String startRegistrationTime = "startRegistrationTime";
  static const String endRegistrationTime = "endRegistrationTime";
  static const String sendRegistrationTime = "sendRegistrationTime";
  static const String receivedRegistrationTime = "receivedRegistrationTime";
  static const String createdDateTime = "createdDateTime";
  static const String updatedDateTime = "updatedDateTime";
  static const String smsRetries = "smsRetries";

  static Set<String> getFields() => {
        trxId,
        trxStatusId,
        trxStatusDescription,
        trxTypeId,
        trxEventId,
        trxEventTypeId,
        primaryMsisdn,
        map,
        state,
        stateInfo,
        retries,
        startRegistrationTime,
        endRegistrationTime,
        sendRegistrationTime,
        receivedRegistrationTime,
        createdDateTime,
        updatedDateTime,
        smsRetries,
      };

  static dynamic getFieldValue(String field, AddRegData addRegData) {
    if (trxId == field) return addRegData.getTrxId();
    if (trxStatusId == field) return addRegData.getTrxStatusId();
    if (trxStatusDescription == field)
      return addRegData.getTrxStatusDescription();
    if (trxTypeId == field) return addRegData.getTrxTypeId();
    if (trxEventId == field) return addRegData.getTrxEventId();
    if (trxEventTypeId == field) return addRegData.getTrxEventTypeId();
    if (primaryMsisdn == field) return addRegData.getPrimaryMsisdn();
    if (map == field) return addRegData.getMap();
    if (state == field) return addRegData.getState();
    if (stateInfo == field) return addRegData.getStateInfo();
    if (retries == field) return addRegData.getRetries();
    if (startRegistrationTime == field)
      return addRegData.getStartRegistrationTime();
    if (endRegistrationTime == field)
      return addRegData.getEndRegistrationTime();
    if (sendRegistrationTime == field)
      return addRegData.getSendRegistrationTime();
    if (receivedRegistrationTime == field)
      return addRegData.getReceivedRegistrationTime();
    if (createdDateTime == field) return addRegData.getCreatedDateTime();
    if (updatedDateTime == field) return addRegData.getUpdatedDateTime();
    if (smsRetries == field) return addRegData.getSmsRetries();

    return null;
  }
}
