/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import '../util/enum.dart';
import '../util/enum_utils.dart';

class Dir extends Enum<Dir> {
  static const LTR = Dir("LTR");
  static const RTL = Dir("RTL");

  const Dir(String name) : super(name);

  static Dir toDir(String dir, bool throwOnMismatch) {
    return EnumUtils.toEnum_(dir, _ENUMS, throwOnMismatch);
  }

  static const List<Dir> _ENUMS = [LTR, RTL];
}
