/*
 * ----------------------------------------------------------------------------
 * Copyright © 2009 by Mobile-Technologies Limited. All rights reserved. All intellectual property rights in and/or in
 * the computer program and its related documentation and technology are the sole Mobile-Technologies Limited property.
 * This computer program is under Mobile-Technologies Limited copyright and cannot be in whole or in part reproduced,
 * sublicensed, leased, sold or used in any form or by any means, including without limitation graphic, electronic,
 * mechanical, photocopying, recording, taping or information storage and retrieval systems without Mobile-Technologies
 * Limited prior written consent. The downloading, exporting or reexporting of this computer program or any related
 * documentation or technology is subject to any export rules, including US regulations.
 * ----------------------------------------------------------------------------
 */

import 'package:mt_formalyze/com/mt/form/structure/my_map.dart';
import 'package:mt_formalyze/com/mt/form/structure/ordered_map.dart';
import 'package:mt_formalyze/com/mt/form/structure/string_object_map.dart';
import 'package:mt_formalyze/com/mt/formalyze/util/log/logger.dart';

void main() {
  {
    Map<String, Object> map = MyMap();
    map['name'] = "Dart";
    map['age'] = 99;

    Logger.debug(map);
  }

  {
    Map<String, Object> map = StringObjectMap();
    map['name'] = 'Flutter';
    map['Name'] = 'Dart';
    map['age'] = 99;
    map['extra'] = 'bla';

    map.remove('EXTRA');

    Logger.debug(map);
  }

  {
    Map<String, Object> map = OrderedMap();
    map['name'] = 'Flutter';
    map['Name'] = 'Dart';
    map['age'] = 99;
    map['extra'] = 'bla';

    Logger.debug(map);
  }
}
